path "models";	// Path to model subdirectory - if any
path "sounds";	// Path to sound subdirectory - if any
path "bmaps";		// Path to graphics subdirectory - if any
path "D:\\A5.20\\template";	// Path to WDL templates subdirectory
path "c:\\A5.20\\template";
include <movement.wdl>;	// libraries of WDL functions
include <messages.wdl>;
include <menu.wdl>;		// menu must be included BEFORE doors and weapons
include <particle.wdl>; // remove when you need no particles
include <doors.wdl>;		// remove when you need no doors
include <actors.wdl>;   // remove when you need no actors
include <weapons.wdl>;  // remove when you need no weapons
include <war.wdl>;      // remove when you need no fighting 

var Squeal_handle = 0;
var esc_hit = 0;
var help_hit = 0;
var dash_view = 0;
var crash_sound;

var path_max = 18;
var path_slow_table[7] = 3,6,10,13,16,21,24;
var slow_max = 0;
var slow_index;
var atime;


define car_speed, Skill48;
define accelerator, Skill47;
//define lap_time, Skill46;
//define race_time, Skill45;
define next_spin, Skill44;
define accel_max, Skill43;
define way_point, Skill42;
define path_count, Skill41;
define spin_out, skill40;
define car_done, skill39;
define lap, skill38;
define path_time,skill37;
define lap_time,skill36;
define lap_start,skill35;

sound wham_snd = <wham.wav>;
sound tire_squeal = <Tire_Squeal.wav>; // Tire squeal sound file
bmap fat_blue_bar = <fat_blue_bar.bmp>;
bmap long_blue_bar = <long_blue_bar.bmp>;
bmap dash_bmp = <dash2.bmp>;
var OK_TO_RACE = 0;
var HOST_START_RACE = 0;
var steps;
var start_count;

var my_player_level = 1;

var sneang = 0;         // Angle of the speedometer needle (calculated)

var start_time;
//var spin_out = 0;
var spin_pan = 0;
var spin_max = 0;
var fix_pan = 0;

var player_speed_max = 210;
var player_accel = 2.5;
var drone_max = 210;

//var accelerator = 0;
var accelerator_1 = 0;
var place_count = 0;

var Race_Done = 0;


var dcl_dll_handle;

dllfunction PlayMP3(file,loop,vol); /* Filename, Loop = 1 yes, Loop = 0 no */
dllfunction StopMP3();
dllfunction SetPreferenceString(subkey,prefname,value_string);
dllfunction GetPreferenceString(subkey,prefname,value_string);
dllfunction SetPreferenceInt(subkey,prefname,value_int);
dllfunction GetPreferenceInt(subkey,prefname,value_int);
dllfunction GetAccurateTime();
dllfunction SendReturnKey();
dllfunction GetInstallPath(path_string);
dllfunction  LaunchExe( exe, params, startdir );
dllfunction ShutDownDLL();
string MP3_Filename = "..\\MP3\\greed_for_speed.mp3";


sound my_crash_1 = <avoid_drivers.wav>;
sound my_crash_2 = <avoid_walls.wav>;
sound my_crash_3 = <Bone_Head.wav>;
sound my_crash_4 = <reshape_car.wav>;
sound my_crash_5 = <Oh_That_Hurt.wav>;


var crash_hand;

sound drone_crash_1 =  <That_Hurt.wav>;
sound drone_crash_2 =  <Trouble.wav>;
sound drone_crash_3 =  <Watch_Out.wav>;

var drone_crash_hand;

var start_race_time = 0;
var start_lap_time = 0;
var end_time = 0;
var lap_time = 0;
var race_time = 0;
//var player_lap_count = 1;
string my_player_name_str [50];
string Line_1_str[50];
string Line_2_str[50];
string Line_3_str[50];
string Line_4_str[50];
string Line_5_str[50];
string Line_6_str[50];
var wham_hand;
var single_size_max;
var single_lap_max;
var setting_music = 0;
var setting_audio = 0;
var setting_video = 1;

font crawl_font, <Fixedsy9.bmp>, 8, 15;
font race_menu_font, <Arial_16.bmp>, 18, 21;
font LCD2, <LCD220.bmp>, 18, 24;

include <drone_5.wdl>;

sound ready_snd = <ready.wav>;
sound three_snd = <three.wav>;
sound two_snd = <two.wav>;
sound one_snd = <one.wav>;
sound go_snd = <go.wav>;

var blimp_view = 0;


function player_client();
function player_race_car();


entity* player1;
entity* player2;
entity* player3;
entity* player4;

entity* tires_player;


var player_start;

var video_mode = 7;	 // screen size 640x480
var video_depth = 32; // 16 bit colour D3D mode
//var car_speed = 0;
//var client_1_car_speed = 0;
var client_2_car_speed = 0;
var client_3_car_speed = 0;
var camera_height = 75;
var camera_distance = 75;
var count = 0;


string racer_mdl = <racer_2.mdl>;
string dcldll_string = <dcldll.dll>;
bmap blue_bar = <blue_bar.bmp>;
sound alert_snd = <alert.wav>;
string checkers_string = <chalk.bmp>;
string track_checkers = <checkers.bmp>;

sound racer_snd = <car_engine.wav>;



var enghandle = 0;
var enghandle_1 = 0;
var drone_enghandle = 0;


string start_multi_1 "Press Space Bar";
string start_multi_2 "To Start Race";


string single_lap_string "         ";
string single_size_string "         ";
string multi_lap_string "         ";
string multi_size_string "         ";
string debug_string "                                                         ";
string temp_string,"    ";
var num_client = 1;

var multi_lap_max;
var multi_size_max;
var car_skin = 1;

var my_height1;
var my_height2;
var my_height3;

bmap Lap_Final_BMAP <final_lap.bmp>;

bmap game_over_bmap <game_over.bmp>;
//bmap game_again_bmap <game_again_over.bmp>;
//bmap game_back_bmap <game_back_over.bmp>;
bmap help_bmap <help.bmp>;

panel help_pan 
{
	pos_x = 0;pos_y = 0;
  layer = 5;
	bmap help_bmap;
	
	alpha = 80;

  flags = transparent,d3d,refresh;
}

panel game_over_pan 
{
	pos_x = 100;pos_y = 96;
  layer = 1;
	bmap game_over_bmap;
	
	alpha = 90;

//	button = 30,68,game_again_bmap,null,game_again_bmap,play_game_again,null,null;
//	button = 500,68,game_back_bmap,null,game_back_bmap,go_back_to_setup,null,null;

  flags = transparent,d3d,refresh;
}


entity Lap_Counter
{
  type = <numb_3.mdl>;
  layer = 2;
  flags = metal;
  view = camera;
  albedo = 30;
  x = 150;
  y = 10;
  z = -15;
  pan = 270;
//  alpha = 70;
//  flags = transparent;   
}

entity Lap_Counter_Tens
{
  type = <numb_1.mdl>;
  layer = 2;
  flags = metal;
  view = camera;
  albedo = 30;
  x = 150;
  y = 50;
  z = -15;
  pan = 270;  
}

bmap speedo = <speedometer.bmp>;

//////////////////////////////////////////////////////
//////  Put a speedometer dial on the screen
panel speeddial
  {
    bmap = speedo;
 	  pos_x = 0;      // Position the speedometer
 	  pos_y = 470;    // Use 4 and 450 for 1024
//	  alpha = 70;     // Set transparency level (Commercial version or higher)
	  flags = refresh, d3d, overlay; // set flags
	  layer = 4;
  }
  
  panel Dash
  {
    bmap = dash_bmp;
 	  pos_x = 0;      // Position the speedometer
 	  pos_y = 357;    // Use 4 and 450 for 1024
//	  alpha = 70;     // Set transparency level (Commercial version or higher)
	  flags = refresh, d3d, overlay; // set flags
	  layer = 4;  
  }


  
panel Lap_Panel_Final
  {
    bmap = Lap_Final_BMAP;
 	  pos_x = 130;      // Position the speedometer
 	  pos_y = 200;    // Use 4 and 450 for 1024
	  alpha = 75;     // Set transparency level (Commercial version or higher)
	  flags = transparent, refresh, d3d, overlay; // set flags

	  layer = 3;
  }
  
  
panel Blue_Bar_Panel
{

    bmap = blue_bar;
 	  pos_x = 0;      // Position the speedometer
 	  pos_y = 580;    // Use 4 and 450 for 1024
	  alpha = 80;     // Set transparency level (Commercial version or higher)
	  flags = transparent, refresh, d3d, overlay; // set flags
	  layer = 6;
}

panel Player_Blue_Bar_Panel
{

    bmap = fat_blue_bar;
 	  pos_x = 4;     
 	  pos_y = 4;    
	  alpha = 25;     // Set transparency level (Commercial version or higher)
	  flags = transparent, refresh, d3d, overlay; // set flags
	  layer = 3;
}

panel Message_Panel_1
{

    bmap = fat_blue_bar;
 	  pos_x = 250;     
 	  pos_y = 200;    
	  alpha = 45;     // Set transparency level (Commercial version or higher)
	  flags = transparent, refresh, d3d, overlay; // set flags
	  layer = 3;
}

panel Message_Panel_2
{

    bmap = fat_blue_bar;
 	  pos_x = 250;     
 	  pos_y = 230;    
	  alpha = 45;     // Set transparency level (Commercial version or higher)
	  flags = transparent, refresh, d3d, overlay; // set flags
	  layer = 3;
}


panel Place_Blue_Bar_Panel
{

    bmap = fat_blue_bar;
 	  pos_x = 4;     
 	  pos_y = 34;    
	  alpha = 25;     // Set transparency level (Commercial version or higher)
	  flags = transparent, refresh, d3d, overlay; // set flags
	  layer = 3;
}

panel Lap_Blue_Bar_Panel
{

    bmap = fat_blue_bar;
 	  pos_x = 496;     
 	  pos_y = 4;    
	  alpha = 25;     // Set transparency level (Commercial version or higher)
	  flags = transparent, refresh, d3d, overlay; // set flags
	  layer = 3;
}

panel Lap_Time_Blue_Bar_Panel
{

    bmap = fat_blue_bar;
 	  pos_x = 496;     
 	  pos_y = 34;    
	  alpha = 25;     // Set transparency level (Commercial version or higher)
	  flags = transparent, refresh, d3d, overlay; // set flags
	  layer = 3;
}

panel Total_Time_Blue_Bar_Panel
{

    bmap = fat_blue_bar;
 	  pos_x = 496;     
 	  pos_y = 64;    
	  alpha = 25;     // Set transparency level (Commercial version or higher)
	  flags = transparent, refresh, d3d, overlay; // set flags
	  layer = 3;
}




text lap1_text
{
	pos_x 440;
	pos_y 10;
	font	msg_font;
}

text game_text_line_1
{
	pos_x 20;
	pos_y 10;
	
	font	race_menu_font;
	layer 99;
	flags = d3d;
}

text game_text_line_2
{
	pos_x 20;
	pos_y 36;
	
	font	race_menu_font;
	layer 99;
	flags = d3d;
}

/*
text game_text_line_3
{
	pos_x 50;
	pos_y 505;
	
	font	LCD2;
	layer 99;
	flags = d3d;
}
*/

panel speedo_panel
{
  layer 10;
  pos_x 50;
  pos_y 505;
  digits  0,0,3,LCD2,1,player.car_speed; 
  flags = refresh,d3d;   
}

text game_text_line_4
{
	pos_x 514;
	pos_y 10;
	
	font	race_menu_font;
	layer 99;
	flags = d3d;
}

text game_text_line_5
{
	pos_x 514;
	pos_y 36;
	
	font	race_menu_font;
	layer 99;
	flags = d3d;
}

text game_text_line_6
{
	pos_x 514;
	pos_y 62;
	
	font	race_menu_font;
	layer 99;
	flags = d3d;
}


text start_game_1
{
	pos_x 260;
	pos_y 202;
	
	font	race_menu_font;
	layer 99;
	flags = d3d;
	
}

text start_game_2
{
	pos_x 260;
	pos_y 232;
	
	font	race_menu_font;
	layer 99;
	flags = d3d;
}


action chalk()
{

  my.scale_y = 9;
  my.scale_x = 9;
  my.oriented = ON;
  

  my.pan = 180;
  my.roll = 90;
  my.tilt = 90;
  
  my.transparent = ON;
  
  my.bright = ON;
  
  my.alpha = 100;
} 

action chalk2()
{

  my.scale_y = 10;
  my.scale_x = 10;
  my.oriented = ON;
  

  my.pan = 270;
  my.roll = 90;
  my.tilt = 90;
  
  my.transparent = ON;
  
  my.bright = ON;
  
  my.alpha = 100;
} 

action chalk3()
{

  my.scale_y = 10;
  my.scale_x = 10;
  my.oriented = ON;
  

  my.pan = 0;
  my.roll = 90;
  my.tilt = 90;
  
  my.transparent = ON;
  
  my.bright = ON;
  
  my.alpha = 100;
} 

action chalk4()
{

  my.scale_y = 10;
  my.scale_x = 10;
  my.oriented = ON;
  

  my.pan = 90;
  my.roll = 90;
  my.tilt = 90;
  
  my.transparent = ON;
  
  my.bright = ON;
  
  my.alpha = 100;
}

/***************
* Smoke effect *
***************/

bmap smoke_parmap=<smoker.bmp>;

function smoke_effect();	// prototype
function smoke_property();	// prototype

function smoke_effect() {
	my.vel_x=0;
	my.vel_y=0;
	my.vel_z=random(3);
	my.move=ON;
//	my.size=15;
  my.size=60;
	my.bmap=smoke_parmap;
	my.flare=ON;
	my.alpha=5;
	my.function=smoke_property;
}

function smoke_property() {
	my.alpha-= .4 * time;
	if (my.alpha<=0) {
		my.lifespan=0;
	}
}

action smoke {
  if (setting_video < 3)
  {
    return;
  }  

	while (1) {
		temp.x=my.x+random(32)-16;
		temp.y=my.y+random(32)-16;
		temp.z=my.z - 20;
		effect(smoke_effect,30*time,temp,temp);
		wait 1;
		if ((my.spin_out == 0) && (fix_pan == 0))
		{
		  break;
		}
	}
}

function start_spin_out()
{
    if (!my.car_done)
    {
      my.spin_out = 1;
      spin_pan = my.pan;
      spin_max = my.car_speed / 3;
      smoke();
    }
}

function drone_spin_out()
{
    drone1.spin_out = 1;
    my = drone1;
    smoke();
}


/*
function car_squeal()
{
  while(1)  // Repeat forever
    { 
      if((my.spin_out) && (snd_playing(Squeal_handle) == 0))
        {
          Squeal_handle = snd_play (tire_squeal, 40, 0);
        }
      else 
        {
          if( !my.spin_out ){snd_stop(Squeal_handle);}
        }
      wait(1);
    }
}  
*/


function start_multi_race()
{
    if (player == null)
    {
      return;
    } 

    if ((player.car_done) || (esc_hit == 1))
    {
      exit;
    }

    if (!HOST_START_RACE)
    {
      HOST_START_RACE = 1;
      send_var(HOST_START_RACE);
      start_game_1.visible = OFF;
  	  start_game_2.visible = OFF;
  	  Message_Panel_1.visible = OFF;
  	  Message_Panel_2.visible = OFF;
	  }

  
  return;
}

function wait_for_host_start
{
  start_game_1.visible = ON;
	start_game_1.string = start_multi_1; 
	start_game_2.visible = ON;
	start_game_2.string = start_multi_2;
	Message_Panel_1.visible = ON;
	Message_Panel_2.visible = ON; 
	
	/*
  while(HOST_START_RACE == 0)
  {
    wait(1);
  }
  */
} 
    
     

function show_debug()
{
//	exclusive_global;		// stop previous msg_show action

	lap1_text.string = debug_string;
	lap1_text.visible = ON;
}

var force = .5;


view Map_Cam {} // Create Map camera.

function blimp_cam() //Target camera. Attributes
{
 blimp_view += 1;
 
 if (blimp_view > 1)
 {
    blimp_view = 0;
 }
 
 if (blimp_view > 0)
 {
  Map_Cam.visible = ON;  //Show View
 }
 else
 {
  Map_Cam.visible = OFF;
 }
 Map_Cam.size_x = 250; //<-- 800x600//128; <--1024x768// Window Size X
 Map_Cam.size_y = 100; //<-- 800x600//120; <--1024x768// Window Size Y
 Map_Cam.pos_x = 250; //<-- 800x600//851; <--1024x768// Window Position X
 Map_Cam.pos_y = 10; //<-- 800x600//614; <--1024x768// Window Position Y
 Map_Cam.tilt = -7.5; // Look Down
 //Map_Cam.pan = camera.pan + 1 ; // Top North
 Map_Cam.Noparticle = ON;
 Map_Cam.audible = OFF;

     while(1) // Need Loop so variables update
     {
       if (blimp_view == 1)
       {
        Map_cam.x = player.x - cos(player.pan) * 100;  // Follow Players X
       }
      
       Map_Cam.y = player.y; // Follow Players Y
       Map_Cam.z = player.z + 20; // Use this to Zoom the Map
       Map_Cam.pan = camera.pan + 180;
      
       wait(1); // Need break in loop so code wont choke
     }
}


function mouse_toggle()
{
	mouse_map = arrow;
	mouse_mode += 2;
	if ( mouse_mode > 2 )
	{
		mouse_mode = 0;
	}
	while ( mouse_mode > 0 )
	{
		mouse_pos.x = pointer.x;
		mouse_pos.y = pointer.y;
		wait( 1 );
	}
}


bmap Loading_bmap = <loading.bmp>;
panel Loading_panel { bmap = loading_bmap; flags = refresh,d3d; }


function main()
{

  Loading_panel.visible = ON;
  
  randomize();

	warn_level = 1;	// announce bad texture sizes and bad wdl code
	tex_share = ON;	// map entities share their textures
	dplay_smooth = .9;
	
	fps_max = 24;
	fps_min = 8;
	
  bmap_preload(Lap_Final_BMAP);
		
	game_text_line_1.string = Line_1_str;
	game_text_line_1.visible = ON;
	game_text_line_2.string = Line_2_str;
	game_text_line_2.visible = ON;
//	game_text_line_3.string = Line_3_str;
//	game_text_line_3.visible = ON;
  speedo_panel.visible = ON;
	game_text_line_4.string = Line_4_str;
	game_text_line_4.visible = ON;
	game_text_line_5.string = Line_5_str;
	game_text_line_5.visible = ON;
	game_text_line_6.string = Line_6_str;
	game_text_line_6.visible = ON;
		
	place_text_1.string = crawl_string;
	place_text_1.visible = ON;

  init_environment();

  dll_handle = dll_open(dcldll_string);
   
  load_level(<short.WMB>);
  

  wait(160);
  

  single_size_max = GetPreferenceInt("SOFTWARE\\DCI\\Great Clips","Racers",single_size_max);
	car_skin = GetPreferenceInt("SOFTWARE\\DCI\\Great Clips","Car Skin",car_skin);
  GetPreferenceString("SOFTWARE\\DCI\\Great Clips","Player Name",my_player_name_str);
  single_lap_max = GetPreferenceInt("SOFTWARE\\DCI\\Great Clips","Single Laps",single_lap_max);
  my_player_level = GetPreferenceInt("SOFTWARE\\DCI\\Great Clips","Skill Level",my_player_level);

  setting_video = GetPreferenceInt("SOFTWARE\\DCI\\Great Clips","Video",setting_video);
  setting_audio = GetPreferenceInt("SOFTWARE\\DCI\\Great Clips","Sound",setting_audio);
  setting_music = GetPreferenceInt("SOFTWARE\\DCI\\Great Clips","Music",setting_music);

  str_cpy (line_4_str,"Lap ");
  str_for_num(temp_string,1);
  str_cat(line_4_str,temp_string);
  str_for_num(temp_string,(single_lap_max));
  str_cat(line_4_str," OF ");
  str_cat(line_4_str,temp_string);
  
  //	player_lap_count = 1;
	
	if (setting_video == 1)
	{
	  clip_range = 30000;
	  camera.fog_start = clip_range * 0.8;
    camera.fog_end = clip_range * 0.9;
	}
	
	if (setting_video == 2)
	{
	  camera.fog_start = clip_range * 0.8;
    camera.fog_end = clip_range * 0.9;
	  clip_range = 60000;
  }
  
  if (setting_video == 3)
	{
	  clip_range = 100000;
	}
  
  game_over = 0;  

    
  if (my_player_level == 1)
  {
    drone_base_speed = 2.2;
    drone_max = 150;
    player_speed_max = 170;
    player_accel = 2.4;
  }
  
  if (my_player_level == 2)
  {
    drone_base_speed = 2.3;
    drone_max = 173;
    player_speed_max = 180;
    player_accel = 2.5;
  }
  
  if (my_player_level == 3)
  {
    drone_base_speed = 2.4;
    drone_max = 185;
    player_speed_max = 190;
    player_accel = 2.6;
  } 
  
  if (setting_music)
  {
    PlayMP3(MP3_Filename,1,-600); //Play the MP3
  }
  
  Blue_Bar_Panel.visible = ON;
  speeddial.visible = ON;
  Player_Blue_Bar_Panel.visible = ON;
  Lap_Blue_Bar_Panel.visible = ON;
  Place_Blue_Bar_Panel.visible = ON;
  Lap_Time_Blue_Bar_Panel.visible = ON;
  Total_Time_Blue_Bar_Panel.visible = ON;

// create the player entity on the client

ifndef client;
    player_start.x = 4000;
    player_start.y = -200;
    player_start.z = 450;
    player = ent_create(racer_mdl,player_start,player_race_car);

    if (single_size_max >= 2)
  	{
    	temp.x = player_start.x + 700;
    	temp.y = player_start.y;
    	temp.z = player_start.z;
    	drone1 = ent_create(racer_mdl,temp,drone_car_1);
    	drone1.accel_max = drone_max + random(5);
  	}
   
  	if (single_size_max >= 3)
  	{
    	temp.x = player_start.x + 700;
    	temp.y = player_start.y - 250;
    	temp.z = player_start.z;
    	drone2 = ent_create(racer_mdl,temp,drone_car_1);
    	drone2.accel_max = drone_max + random(5);
  	}
  	
  	if (single_size_max >= 4)
  	{
    	temp.x = player_start.x + 1400;
    	temp.y = player_start.y;
    	temp.z = player_start.z;
    	drone3 = ent_create(racer_mdl,temp,drone_car_1);
    	drone3.accel_max = drone_max + random(5);
  	}
  	
  	if (single_size_max >= 5)
  	{
    	temp.x = player_start.x + 1400;
    	temp.y = player_start.y - 250;
    	temp.z = player_start.z;
    	drone4 = ent_create(racer_mdl,temp,drone_car_1);
    	drone4.accel_max = drone_max + random(5);
  	}
  	
  	if (single_size_max >=6)
  	{
    	temp.x = player_start.x + 2100;
    	temp.y = player_start.y;
    	temp.z = player_start.z;
    	drone5 = ent_create(racer_mdl,temp,drone_car_1);
    	drone5.accel_max = drone_max + random(5); 
  	}
  	
  	if (single_size_max >= 7)
  	{
    	temp.x = player_start.x + 2100;
    	temp.y = player_start.y - 250;
    	temp.z = player_start.z;
    	drone6 = ent_create(racer_mdl,temp,drone_car_1);
    	drone6.accel_max = drone_max + random(5);
  	}
  	
  	if (single_size_max >= 8)
  	{
    	temp.x = player_start.x + 2800;
    	temp.y = player_start.y;
    	temp.z = player_start.z;
    	drone7 = ent_create(racer_mdl,temp,drone_car_1);
    	drone7.accel_max = drone_max + random(5);
  	}
  	
  	if (single_size_max >= 9)
  	{
    	temp.x = player_start.x + 2800;
    	temp.y = player_start.y - 250;
    	temp.z = player_start.z;
    	drone8 = ent_create(racer_mdl,temp,drone_car_1);
    	drone8.accel_max = drone_max + random(5);
  	}
  	
  	if (single_size_max >= 10)
  	{
    	temp.x = player_start.x + 3500;
    	temp.y = player_start.y;
    	temp.z = player_start.z;
    	drone9 = ent_create(racer_mdl,temp,drone_car_1);
    	drone9.accel_max = drone_max + random(5);
  	}
  	
  	if (single_size_max >= 11)
  	{
    	temp.x = player_start.x + 3500;
    	temp.y = player_start.y - 250;
    	temp.z = player_start.z;
    	drone10 = ent_create(racer_mdl,temp,drone_car_1);
    	drone10.accel_max = drone_max + random(5);
  	}
  	
  	if (single_size_max >= 12)
  	{
    	temp.x = player_start.x + 4200;
    	temp.y = player_start.y; 
    	temp.z = player_start.z;
    	drone11 = ent_create(racer_mdl,temp,drone_car_1);
    	drone11.accel_max = drone_max + random(5);
  	}
  	
  	if (single_size_max >= 13)
  	{
    	temp.x = player_start.x + 4200;
    	temp.y = player_start.y - 250;
    	temp.z = player_start.z;
    	drone12 = ent_create(racer_mdl,temp,drone_car_1);
    	drone12.accel_max = drone_max + random(5);
  	}
  	
  	if (single_size_max >= 14)
  	{
    	temp.x = player_start.x + 4900;
    	temp.y = player_start.y;
    	temp.z = player_start.z;
    	drone13 = ent_create(racer_mdl,temp,drone_car_1);
    	drone13.accel_max = drone_max + random(5);
  	}
  	
  	if (single_size_max >= 15)
  	{
    	temp.x = player_start.x + 4900;
    	temp.y = player_start.y - 250;
    	temp.z = player_start.z;
    	drone14 = ent_create(racer_mdl,temp,drone_car_1);
    	drone14.accel_max = drone_max + random(5);
  	}
  	
  	if (single_size_max >= 16)
  	{
    	temp.x = player_start.x + 5600;
    	temp.y = player_start.y;
    	temp.z = player_start.z;
    	drone15 = ent_create(racer_mdl,temp,drone_car_1);
    	drone15.accel_max = drone_max + random(5);
  	}
  	
  }		

endif;

  
ifdef client;

  racer_client_move();	// enable multiuser mode
  

// wait until the level is loaded, and the connection is established
	while (connection == 0) { wait(1); }


// create a client entity at a random place
  player_start.x = -10000;
  player_start.y = -5700;
  player_start.z = 100;
  
	player = ent_create(racer_mdl,player_start,player_client);
	
	/*
	wait_for_host_start();
	while(1)
	{
  	if (HOST_START_RACE == 1)
    {
      start_game_1.visible = OFF;
	    start_game_2.visible = OFF;
	    Message_Panel_1.visible = OFF;
	    Message_Panel_2.visible = OFF;
      start_race();
      goto race_started; 
    }
    wait (1);
  }
  
  race_started:
  */
   
  	 
endif;
// display the server's IP address
ifdef server;
	while (connection == 0) { wait(1); }
	str_cpy(temp_str,server_name);
	str_cat(temp_str," ");
	str_cat(temp_str,server_ip);
	scroll_message(temp_str);
endif;
  
}


function start_race()
{

    start_time = GetAccurateTime() + 5;
    OK_TO_RACE = 0;
    steps = 0;
    start_count = 5;
    

//    breakpoint;

    
    while (start_count > 0)
    {
      start_count = start_time - GetAccurateTime();
      
      if ((int(start_count) == 5) && (steps == 0))
	    {
      	 play_sound(ready_snd,100);
	       steps = 1;
	    }

		  if ((int(start_count) == 3) && (steps == 1))
		  {
		    steps = 2;
		    
		    Lap_Counter.visible = ON;
	      play_sound(three_snd,100);
		  }
		  
		  if ((int(start_count) == 2) && (steps == 2))
		  {
		    steps = 3;
		    ent_morph(Lap_Counter,"numb_2.mdl");
		    play_sound(two_snd,100);
		  }
		  
		  if ((int(start_count) == 1) && (steps == 3))
		  {
		    steps = 4;
		    ent_morph(Lap_Counter,"numb_1.mdl");
		    play_sound(one_snd,100);
		  }
		
		  if ((int(start_count) == 0) && (steps == 4))
		  {
		    steps = 0;
		    //Lap_Counter.y = -50;
		    ent_morph(Lap_Counter,"go.mdl");

		    play_sound(go_snd,100);
		    OK_TO_RACE = 1;
		    start_race_time = GetAccurateTime();
		    start_lap_time = start_race_time;  
		    place_count = 0;
		    while (Lap_Counter.pan > -180)
		    {
		      if (setting_video == 3)
		      {
		        Lap_Counter.pan -= 5;
		      }
		      if (setting_video == 2)
		      {
		        Lap_Counter.pan -= 10;
		      }
		      if (setting_video == 1)
		      {
		        Lap_Counter.pan -= 18;
		      }
		      
		      wait(1);
		    } 
		  }		  
		  wait(1);
		  
		}
		Lap_Counter.visible = OFF;
		
		return;
}



var tens;
var ones;
var wait_amount;

function show_lap_count()
{
  if (player.lap == single_lap_max)
  {
    Lap_Panel_Final.visible = ON;
  }

  wait_amount = 270;
  while (wait_amount > 0)
  {
    wait_amount -= 5;
    wait(1);
  }

	Lap_Panel_Final.visible = OFF;	
	return;
}		  



/////////////////////////////////////////////////////////////////////////
// Desc: used in multiplayer (client/server) games
//			set client_moving var to 1
//			take user input use that to adjust the 'player' forces
//			SEND player forces to the server
//       move the camera
//
// Call: _player_intentions
//			move_view

function racer_client_move()
{
	client_moving = 1;
	while(1)
	{
		_player_intentions();// user key/mouse input sets force and aforce values

		// player created on the client?
		if (player)
		{
			vec_set(player._FORCE_X,force);
			vec_set(player._AFORCE_PAN,aforce);

		// send player forces to server
			send_vec(player._FORCE_X);
			send_vec(player._AFORCE_PAN);

		// move the camera
			move_carview();
		}
		wait(1);
	}
}



function player_client()
{
	my.skin = num_client;
	
	my.shadow = ON;
	
	/*
	 player_start.x = -10000;
  player_start.y = -5700;
  player_start.z = 100;
	*/
	
	
//	if (my.skin==1){my.x = 6200;my.y = -200;my.z = 15;}
	if (my.skin==2){my.x = -9600;my.y = -5700;my.z = 100;}

	if (my.skin ==1){player1 = my;while (player1 == null){wait(1);}}
	if (my.skin ==2){ player2 = my;while (player2 == null){wait(1);}}
	if (my.skin ==3){ player3 = my;while (player3 == null){wait(1);}}
	if (my.skin ==4){ player4 = my;while (player4 == null){wait(1);}}
	num_client += 1;
	if (num_client > 4){wait(1);remove (me);return;}
	my.enable_disconnect = ON;
	my.event = _actor_connect;
	
  if (my.skin == 1)
  {
    player_race_car_1();
  }
  
  if (my.skin == 2)
  {
    player_race_car_2();
  }
  
  send_variables();
}

function send_variables()
{
  
    while(1)
    {
    
      if (player1)
      {
        send(player1.car_speed);
        send(player1.accelerator);
      }
      
      if (player2)
      {
        send(player2.car_speed);
        send(player2.accelerator);
      }   
        
      wait(1);
    }
}    


bmap my_sky = <sky06.bmp>,0,0,128,128;
bmap my_clouds = <sky06.bmp>,128,0,128,128;
bmap my_mountains = <sky16.bmp>;

// Desc: set up the sky, cloud, and scene maps
function init_environment()
{
/*
	sky_map = my_sky;
	cloud_map = my_clouds;
	scene_map = my_mountains;

	scene_field = 90;
	scene_angle.tilt = -10;
*/
	sky_speed.x = 0;
	sky_speed.y = 0;
//	cloud_speed.x = .3;
//	cloud_speed.y = 1;

//	sky_scale = .10;
//	sky_curve = 4;

//	fog_color = 1;
	
//	camera.fog_start = clip_range * 0.8;
//	camera.fog_end = clip_range * 0.9;

//	Map_Cam.fog_start = clip_range * 0.8;
//	Map_Cam.fog_end = clip_range * 0.9;		
	
			
}

function hit_wall()
{

  return;
  
  if (event_type == event_entity)
	{
    if ((snd_playing(wham_hand) == 0) && (setting_audio))
    {
      wham_hand = ent_playsound(my,wham_snd,1000);
      my.car_speed = my.car_speed * .90;
      my.accelerator = my.accelerator * .90;	
    }		
  }    

	if (event_type == event_block)
	{
    if ((snd_playing(wham_hand) == 0) && (setting_audio))
    {
      wham_hand = ent_playsound(my,wham_snd,1000);
      my.car_speed = my.car_speed * .90;
      my.accelerator = my.accelerator * .90;
    }		
				
		vec_for_vertex(hit_vec,my,487);
		
		x_diff = my.x - hit_vec.x;
		y_diff = my.y - hit_vec.y;
		z_diff = my.z - hit_vec.z;
		
    if (abs(x_diff) > abs(y_diff))
    {
  		if (x_diff < 0)
  		{
  		   my.pan += normal.y;
  		}
  		else
  		{
  		  my.pan -= normal.y;
  		}
		}
		else
		{
		  if (y_diff > 0)
  		{
  		   my.pan += normal.x;
  		}
  		else
  		{
  		  my.pan -= normal.x;
  		}
  	} 

  }

}

var max_crawl_size;

function player_race_car()
{

  Loading_panel.visible = OFF;
	bmap_purge(Loading_bmap);

	my.enable_block = OFF;
	my.enable_entity = ON;
	my.enable_impact = OFF;
	my.event = hit_wall;

//  player = me;

  ifndef client;
    my.skin = car_skin;
  endif;
  
  if (setting_video == 3)
  {
    my.shadow = ON;
  }
  
  my.ambient = 25;
 
  my.scale_x = 1.75;
	my.scale_y = 1.75;
	my.scale_z = 1.75;
  
	my.fat = ON;
  my.narrow = OFF;
  
  if (my_player_level == 1)
  {
    my.next_spin =  3 + random(7);
  }
  
  if (my_player_level == 2)
  {
    my.next_spin = 2 + random(5);
  }
  
  if (my_player_level == 3)
  {
    my.next_spin = 1 + random(3);
  } 
   
  str_cpy(line_1_str,my_player_name_str);
  
  move_carview();
   

 // ifndef client;
    scan_track_player();
  	adjust_for_slope();
    wait_for_host_start();
    while (HOST_START_RACE == 0)
    {
      wait (1);
    }
    start_race();
//  endif;


  my.accelerator = 0;
  my.path_count = 0;
  my.way_point = 0;
  my.spin_out = 0;
  my.car_done = 0;
  my.lap = 1;
  
  str_cpy (line_4_str,"Lap ");
  str_for_num(temp_string,my.lap);
  str_cat(line_4_str,temp_string);
  str_for_num(temp_string,(single_lap_max));
  str_cat(line_4_str," OF ");
  str_cat(line_4_str,temp_string); 
  
//  car_squeal(); 

  
	while(1)
	{
	  if (my.car_done)
	  {
	    game_over_pan.visible = ON;
//	    mouse_toggle();
	  }
	
    car_force();
	  scan_track_player();
	  adjust_for_slope();
	  if (client_moving == 1)
	  {
	    move_player_car_mod();
     	if (player.frame < 17)
	      {
 	      if (my.car_speed > 0) 
		    {
		      my.frame += 1 + (my.car_speed / 20);
          if (my.frame > 15) 
          {
            my.frame = 0;
          }
        }
        if (my.car_speed < 0) 
		    {
		      my.frame -= 1 + (my.car_speed / 20);
          if (my.frame < 0) 
          {
            my.frame = 15;
          }
        }
      }      
	  }
	  else
	  {
	    if (player)
	    {
	      move_single_player_car();
 	      if (player.frame < 17)
 	      {
   	      if (my.car_speed > 0) 
  		    {
  		      my.frame += 1 + (my.car_speed / 20);
            if (my.frame > 15) 
            {
              my.frame = 0;
            }
          }
          if (my.car_speed < 0) 
  		    {
  		      my.frame -= 1 + (my.car_speed / 20);
            if (my.frame < 0) 
            {
              my.frame = 15;
            }
          }
        }      
	    }
	  }
	  
	  scan_track_player();
	  adjust_for_slope();
	  
		if ((enghandle == 0) && (setting_audio))
		{
      play_loop racer_snd,30;
  		enghandle = result;			
	  }
// tune the sound depending on speed_ahead
  
    if (my.car_speed < 70)
    {
		  temp = 100 + (my.car_speed * 2.5);     // 100 - 275
		}
		if ((my.car_speed > 70) && (my.car_speed < 110)) // 175 - 275
		{
		  temp = (my.car_speed) * 2.5;
    }
		if ((my.car_speed > 110) && (my.car_speed < 145)) // 175 - 297.5
		{
		  temp = my.car_speed - 50;
		  temp = temp * 3.5;
		}
		if (my.car_speed > 145)   //255 - 313 
		{
		  temp = (my.car_speed+25) * .65;
		  temp = temp * 3;	
		}
		
		if (enghandle)
		{
		  tune_sound enghandle,25,temp;
		}
		
  	if (!my.car_done)
  	{
    	lap_time = GetAccurateTime() - start_lap_time;
    	race_time = GetAccurateTime() - start_race_time;
    	if (!OK_TO_RACE)
    	{
    	  lap_time = 0;
    	  race_time = 0;
    	}
  	}
  
  	/*
  	str_for_num(temp_string,int(my.car_speed));
  	str_cpy(line_3_str,temp_string);
  	*/
  	
  	
  	if (crawl_len > 100)
  	{
    	place_text_1.pos_x -= 2;
    	
    	max_crawl_size = -((8 * crawl_len) - 400);
    	
    	if (place_text_1.pos_x < max_crawl_size)
    	{
    	  place_text_1.pos_x = 400;
    	  play_sound(alert_snd,100);
    	}
  	}


    str_cpy (line_5_str,"Lap ");
    str_for_num(temp_string,int(lap_time));
    str_cat(line_5_str,temp_string);
    str_for_num(temp_string,frc(lap_time));
    str_clip(temp_string,1);
    str_cat(line_5_str,temp_string);
    
    str_cpy (line_6_str,"Race ");
    str_for_num(temp_string,int(race_time));
    str_cat(line_6_str,temp_string);
    str_for_num(temp_string,frc(race_time));
    str_clip(temp_string,1);
    str_cat(line_6_str,temp_string);
  
		wait(1);
	}
	
  if (dll_handle != null)
  {
    StopMP3();
    ShutDownDLL();
    dll_close(dll_handle);
    dll_handle = null;   
  }
}

function player_race_car_1()
{


/*
	player2.enable_block = OFF;
	player2.enable_entity = ON;
	player2.enable_impact = OFF;
	player2.event = hit_wall;
*/

  player1.shadow = ON;
  
  player1.ambient = 50;
 
  player1.scale_x = 1.75;
	player1.scale_y = 1.75;
	player1.scale_z = 1.75;
  
	player1.fat = ON;
  player1.narrow = OFF;
  
  str_cpy(line_1_str,my_player_name_str);
  
  str_cpy (line_4_str,"Lap ");
  str_for_num(temp_string,player.lap);
  str_cat(line_4_str,temp_string);
  str_for_num(temp_string,(single_lap_max));
  str_cat(line_4_str," OF ");
  str_cat(line_4_str,temp_string);  
  
    scan_track_player();
  	adjust_for_slope();
    wait_for_host_start();
    while (HOST_START_RACE == 0)
    {
      wait (1);
    }
    start_race();
  
  my.car_done = 0;

 // breakpoint;
 // start_time = GetAccurateTime();
  
	while(1)
	{
    car_force();
	  scan_track_player();
	  adjust_for_slope();
	  if (client_moving == 1)
	  {
	    move_player_car_mod();
     	if (player1.frame < 17)
	      {
 	      if (player1.car_speed > 0) 
		    {
		      player1.frame += 1 + (player1.car_speed / 20);
          if (player1.frame > 15) 
          {
            player1.frame = 0;
          }
        }
        if (player1.car_speed < 0) 
		    {
		      player1.frame -= 1 + (player1.car_speed / 20);
          if (player1.frame < 0) 
          {
            player1.frame = 15;
          }
        }
      }      
	  }

	  scan_track_player();
	  adjust_for_slope();
	  

		if (enghandle_1 == 0)
		{
      play_loop racer_snd,20;
  		enghandle_1 = result;			
	  }
// tune the sound depending on speed_ahead
  
    if (player1.car_speed < 70)
    {
		  temp = 100 + (player1.car_speed * 2.5);     // 100 - 275
		}
		if ((player1.car_speed > 70) && (player1.car_speed < 110)) // 175 - 275
		{
		  temp = (player1.car_speed) * 2.5;
    }
		if ((player1.car_speed > 110) && (player1.car_speed < 145)) // 175 - 297.5
		{
		  temp = player1.car_speed - 50;
		  temp = temp * 3.5;
		}
		if (player1.car_speed > 145)   //255 - 313 
		{
		  temp = (player1.car_speed+25) * .65;
		  temp = temp * 3;	
		}
		
		tune_sound enghandle_1,20,temp;

		
		
  	if (!my.car_done)
  	{
    	lap_time = GetAccurateTime() - start_lap_time;
    	race_time = GetAccurateTime() - start_race_time;
    	if (!OK_TO_RACE)
    	{
    	  lap_time = 0;
    	  race_time = 0;
    	}
  	}
  	
  	/*
 
    str_cpy (line_5_str,"Lap ");
    str_for_num(temp_string,int(lap_time));
    str_cat(line_5_str,temp_string);
    str_for_num(temp_string,frc(lap_time));
    str_clip(temp_string,1);
    str_cat(line_5_str,temp_string);
    
    str_cpy (line_6_str,"Race ");
    str_for_num(temp_string,int(race_time));
    str_cat(line_6_str,temp_string);
    str_for_num(temp_string,frc(race_time));
    str_clip(temp_string,1);
    str_cat(line_6_str,temp_string);
    */
    
		wait(1);
	}
	
  if (dll_handle != null)
  {
    StopMP3();
    ShutDownDLL();
    dll_close(dll_handle);
    dll_handle = null;   
  }
}



function player_race_car_2()
{


/*
	player2.enable_block = OFF;
	player2.enable_entity = ON;
	player2.enable_impact = OFF;
	player2.event = hit_wall;
*/

  player2.shadow = ON;
  
  player2.ambient = 50;
 
  player2.scale_x = 3;
	player2.scale_y = 3;
	player2.scale_z = 3;
  
	player2.fat = ON;
  player2.narrow = OFF;
  
  str_cpy(line_1_str,my_player_name_str);
  
  str_cpy (line_4_str,"Lap ");
  str_for_num(temp_string,player.lap);
  str_cat(line_4_str,temp_string);
  str_for_num(temp_string,(single_lap_max));
  str_cat(line_4_str," OF ");
  str_cat(line_4_str,temp_string);  
  
/*
  ifdef client;
  scan_track_player();
	adjust_for_slope();
  wait_for_host_start();
  while (HOST_START_RACE == 0)
  {
    wait (1);
  }
  
  start_race();
  
  endif;
  */
  
  my.car_done = 0;

 // breakpoint;
 // start_time = GetAccurateTime();
  
	while(1)
	{
    car_force();
	  scan_track_player();
	  adjust_for_slope();
	  if (client_moving == 1)
	  {
	    move_player_car_mod();
     	if (player2.frame < 17)
	      {
 	      if (player2.car_speed > 0) 
		    {
		      player2.frame += 1 + (player2.car_speed / 20);
          if (player2.frame > 15) 
          {
            player2.frame = 0;
          }
        }
        if (player2.car_speed < 0) 
		    {
		      player2.frame -= 1 + (player2.car_speed / 20);
          if (player2.frame < 0) 
          {
            player2.frame = 15;
          }
        }
      }      
	  }

	  scan_track_player();
	  adjust_for_slope();
	  
	  /*
		if (enghandle_1 == 0)
		{
      play_loop racer_snd,20;
  		enghandle_1 = result;			
	  }
// tune the sound depending on speed_ahead
  
    if (player2.car_speed < 70)
    {
		  temp = 100 + (player2.car_speed * 2.5);     // 100 - 275
		}
		if ((player2.car_speed > 70) && (player2.car_speed < 110)) // 175 - 275
		{
		  temp = (player2.car_speed) * 2.5;
    }
		if ((player2.car_speed > 110) && (player2.car_speed < 145)) // 175 - 297.5
		{
		  temp = player2.car_speed - 50;
		  temp = temp * 3.5;
		}
		if (player2.car_speed > 145)   //255 - 313 
		{
		  temp = (player2.car_speed+25) * .65;
		  temp = temp * 3;	
		}
		tune_sound enghandle_1,20,temp;
		*/
		
		
  	if (!my.car_done)
  	{
    	lap_time = GetAccurateTime() - start_lap_time;
    	race_time = GetAccurateTime() - start_race_time;
    	if (!OK_TO_RACE)
    	{
    	  lap_time = 0;
    	  race_time = 0;
    	}
  	}
  	
  	/*
 
    str_cpy (line_5_str,"Lap ");
    str_for_num(temp_string,int(lap_time));
    str_cat(line_5_str,temp_string);
    str_for_num(temp_string,frc(lap_time));
    str_clip(temp_string,1);
    str_cat(line_5_str,temp_string);
    
    str_cpy (line_6_str,"Race ");
    str_for_num(temp_string,int(race_time));
    str_cat(line_6_str,temp_string);
    str_for_num(temp_string,frc(race_time));
    str_clip(temp_string,1);
    str_cat(line_6_str,temp_string);
    */
    
		wait(1);
	}
	
  if (dll_handle != null)
  {
    StopMP3();
    ShutDownDLL();
    dll_close(dll_handle);
    dll_handle = null;   
  }
}



function scan_track_player()
{

	vec_set(vecFrom,my.x);
	vec_set(vecTo,my.x);

	vecTo.z -= 250;
	vecFrom.z -= 38;

	trace_mode = ignore_sprites + ignore_passents + ignore_models + ignore_me;
  my_height  = trace(vecFrom,vecTo);
  	 	
	trace_mode = ignore_me + ignore_passable + ignore_models + ignore_sprites + scan_texture;
	vec_set(vecFrom,my.x);
	vecFrom.z -= 2.5;
	vec_set(vecTo,my.x);
	vecTo.z -= 100;
	str_cpy (tex_name,"space");
	trace(vecFrom,vecTo); 
	
	ifndef client;
	if (str_cmpi("grass",tex_name))
	{
	  if (my.car_speed > 40)
	  {
  	  my.car_speed = my.car_speed * .995;
  	  my.accelerator = my.accelerator * .995; 
	  } 
	}
	if (str_cmpi("Road_2",tex_name))
	{
		if (my.car_speed > 40)
	  {
  	  my.car_speed = my.car_speed * .995;
  	  my.accelerator = my.accelerator * .995; 	
	  }  
	}
	endif;
	
	ifdef client;
	if (str_cmpi("grass",tex_name))
	{
	  if (my.skin == 1)
	  {
	    my.car_speed = player1.car_speed * .90;
	  }
	  if (my.skin == 2)
	  {
	    player2.car_speed = player2.car_speed * .90;	  
	  }
	  if (my.skin == 3)
	  {
	    client_2_car_speed = client_2_car_speed * .90;	  
	  }
	   if (my.skin == 4)
	  {
	    client_3_car_speed = client_3_car_speed * .90;	  
	  }
	}
	endif;

  count += 1;
  
	my_floornormal.x = normal.x; 	// set my_floornormal to the normal of the surface
	my_floornormal.y = normal.y;
	my_floornormal.z = normal.z;
	
	my.z -= my_height;

}

var turn_ratio;
var dist = 100;
var move_amount;


function move_single_player_car()
{
		if (my.car_speed != 0)
		{
		  if (joy_force.x != 0)
		  {
			  player.pan -= 0.2 * (joy_force.x * .25) * my.car_speed * time;
			}
			else
		  {
			  //player.pan -= 0.2 * key_force.x * car_speed * time;
			  if (key_force.x != 0)
			  {
  			  turn_ratio = player_speed_max / my.car_speed;
  			  if (turn_ratio > 4)
  			  {
  			    turn_ratio = 4;
  			  } 
  			  
  			  if (my_player_level == 1)
  			  {
  			    player.pan -= (1.2 * turn_ratio) * key_force.x *  time;
  			  }
  			  if (my_player_level == 2)
  			  {
  			   player.pan -= (1.1 * turn_ratio) * key_force.x *  time;
  			  }
  			  if (my_player_level == 3)
  			  {
  			   player.pan -= (1.0 * turn_ratio) * key_force.x *  time;
  			  }
  			  
  			  if (my.car_speed > (player_speed_max * .85))
  			  {
  			    my.accelerator = my.accelerator * .9985;
  			    my.car_speed = my.car_speed * .9985;
  			  }
			  }
			  if (key_force.x < 0)
			  {			  
			    if (player.frame < 17)
			    {
			      player.frame = 19;
			    }
			    
	        player.frame += 1;
	        if (player.frame > 26)
	        {
	          player.frame = 26;
	        }        	       
			  }
	
			  if (key_force.x > 0)
			  {			 		 			     
			    if (player.frame < 27)
			    {
			      player.frame = 27;
			    }
			    player.frame += 1;
	
  			  if (player.frame > 35)
  			  {
  			    player.frame = 35;
  			  } 
  			}
  			  
			  if (key_force.x == 0)
			  {
			    if (player.frame > 1) 
			    {
			      player.frame -= 1;
			      if (player.frame == 27)
			      {
			        player.frame = 1;
			      }
			    }
			  }
	
			}
		}
		//car_speed = 3 * key_force.y * time + max( 1 - time * 0.1,0) * car_speed;
		if (joy_1 != 0)
		{
		  key_force.y = 1;
		}
		if (joy_force.y != 0)
		{
		  key_force.y = joy_force.y;
		}
		
		if (key_force.y < 0)
		{
		  my.accelerator += (key_force.y * .10);
		}
		
		if (key_force.y > .5)
		{
		  if (my.car_speed < player_speed_max)
		  {
		      my.accelerator += (key_force.y * .15);
		  }
		  if (my.accelerator > player_speed_max)
		  {
		    my.accelerator = player_speed_max;
		  } 
		}
		else
		{
		  my.accelerator = my.accelerator * .99;
		  if ((my.accelerator < 0) && (key_force.y >= 0))
		  {
		    my.accelerator = 0;
		  }
		}
    
    if (my.car_done == 1) 
    {
      my.accelerator -= 2;
      if (my.accelerator < 0)
      {
        my.accelerator = 0;
      }
    }
    
    if (my.spin_out > 0)
    {
      if (my.car_speed > (player_speed_max * .15))
      { 
        my.car_speed = my.car_speed * .5;
        my.accelerator = my.accelerator * .5;
      }
      my.spin_out += 1;
      if (my.spin_out < 20)
      {
        my.pan += 20;
        if ((my.spin_out % 3) == 0)
        {
          my.roll += 20;
        }
        if ((my.spin_out % 3) == 2)
        {
          my.roll -= 20;
        }
      } 
      if ((my.spin_out > 20) && (my.spin_out < 35))
      {
        my.pan += 16;
        if ((my.spin_out % 3) == 0)
        {
          my.roll += 10;
        }
        if ((my.spin_out % 3) == 2)
        {
          my.roll -= 10;
        }
      }  
      if ((my.spin_out > 35) && (my.spin_out < 50))
      {
        my.pan += 10;
      } 
      if (my.spin_out > 50) 
      {
        my.pan += 5;
      }       

      
      if (my.pan > 360)
      {
        my.pan = my.pan - 360;
      }

      if (my.spin_out > spin_max)
      {
        my.spin_out = 0;
        if (dash_view == 0)
        {
          fix_pan = 1;
        }
        
        crash_sound = random(15);

        if ((crash_sound > 0) && (crash_sound < 1))
        {
          crash_hand = snd_play (my_crash_1, 100, 0);
        }
        if ((crash_sound > 3) && (crash_sound < 4))
        {
          crash_hand = snd_play (my_crash_2, 100, 0);
        }
        if ((crash_sound > 5) && (crash_sound < 6))
        {
          crash_hand = snd_play (my_crash_3, 100, 0);
        }
        if ((crash_sound > 7) && (crash_sound < 8))
        {
          crash_hand = snd_play (my_crash_4, 100, 0);
        }
        if ((crash_sound > 11) && (crash_sound < 12))
        {
          crash_hand = snd_play (my_crash_5, 100, 0);
        }

      }
    }
    
		my.car_speed = (player_accel * my.accelerator * time) + max( 1 - time * 0.1,0)  * (my.car_speed / 2);

		
		if (my.car_speed > player_speed_max)
	  {
	    my.car_speed = player_speed_max;
	  }
	  
	  if (OK_TO_RACE < 1)
	  {
  	  my.car_speed = 0;
      my.accelerator = 0;
    }
	
    if (OK_TO_RACE > 0)
    {

      trace_mode = ignore_sprites + ignore_me + ignore_passable +  use_box;
      vec_set(temp,my.x);
      temp.x = temp.x + cos(my.pan) * 300;
      temp.y = temp.y + sin(my.pan) * 200;

      dist = trace (my.x,temp);
      
      
      if ((dist < my.car_speed) && (dist != 0))
      {
      	vec_for_vertex(hit_vec,my,487);
	
    		x_diff = my.x - hit_vec.x;
    		y_diff = my.y - hit_vec.y;
    		z_diff = my.z - hit_vec.z;
		
        if (abs(x_diff) > abs(y_diff))
        {
      		if (x_diff < 0)
      		{
      		   my.pan += normal.y;
      		}
      		else
      		{
      		  my.pan -= normal.y;
      		}
    		}
    		else
    		{
    		  if (y_diff > 0)
      		{
      		  my.pan += normal.x;
      		}
      		else
      		{
      		  my.pan -= normal.x;
      		}
      	}
      	     	
      	if ((snd_playing(wham_hand) == 0) && (setting_audio))
        {
          wham_hand = ent_playsound(my,wham_snd,1000);
          
          if (my.car_speed > (player_speed_max * .45))
          {
            my.next_spin = my.next_spin -1;
            if (my.next_spin < 1)
            {
              start_spin_out();
              Squeal_handle = snd_play (tire_squeal, 80, 0);
              
              if (my_player_level == 1)
              {
                my.next_spin = 3 + random(7);
              }
              
              if (my_player_level == 2)
              {
                my.next_spin = 2 + random(5);
              }
              
              if (my_player_level == 3)
              {
                my.next_spin = 1 + random(3);
              } 
  
            }
          }
        }
      	
      	my.car_speed = my.car_speed * .97;
      	my.accelerator = my.accelerator * .97;
      }
           
      move_mode = ignore_passable + ignore_sprites + use_box + glide;
      if (!my.spin_out)
      {
			  ent_move(my.car_speed,nullvector);
			}
			else
			{
			  temp.y = sin(spin_pan) * my.car_speed;
			  temp.x = cos(spin_pan) * my.car_speed;
			  temp.z = 0;
			  ent_move(nullvector,temp);
			  scan_track_player();
	      adjust_for_slope();			
			}

		}

				
		move_carview();
		
		if ((my.path_count + 1) < 10)
	  {
	    str_cpy(paths,"Path_00");
	  }
	  else
	  {
	    str_cpy(paths,"Path_0"); 
	  }
	  str_for_num(temp_string,(my.path_count + 1));
	  str_cat(paths,temp_string);
	  
	  ent_path (paths);
	  
  	if (result > 0)
  	{
        ent_waypoint(my._TARGET_X,2);
        temp.x = my._TARGET_X - my.x;
	      temp.y = my._TARGET_Y - my.y;
	      temp.z = 0;
	      result = vec_to_angle(my_angle,temp);
	      atime = GetAccurateTime();
	      if (my.lap == 1)
		    {
		        my.lap_start = start_time;
		    }
	      if (result < 3500)
	      {
	        my.path_time = atime - start_time;
	        my.path_count += 1;
	        my.lap_time = atime - my.lap_start;
          if (my.path_count > path_max)
          { 
		        if (my.x > 10000)
            { 
              start_lap_time = atime;
              my.path_count = 0;
              my.lap += 1;
              my.lap_start = atime;
              my.lap_time = 0;
              my.path_time = atime - start_time;
              show_lap_count();
            }
         
            if (my.lap > single_lap_max)
            {
              my.car_done = 1;
            }
            else
            {
              str_cpy (line_4_str,"Lap ");
              str_for_num(temp_string,my.lap);
              str_cat(line_4_str,temp_string);
              str_for_num(temp_string,(single_lap_max));
              str_cat(line_4_str," OF ");
              str_cat(line_4_str,temp_string);  
            }
          }
        }          
        set_places();   
  	}

}

/////////////////////////////////////////////////////////////////////////
// Desc: set force and aforce values
//			these values come from _player_intentions (single player)
//		  or from the client (multiplayer)
//
//	Calls: _player_intentions
//
//	Called From: player_move()
//
function car_force()
{
	// If the camera does not move itself
//	if (_camera == 0)
//	{
		// multiplayer mode
		if (client_moving)
		{
			// get forces from server
//jcl 03/15/01
			vec_set(force,my._FORCE_X);
//			vec_set(aforce,my._FORCE_Y);
		}
		else
		{
			// get forces from user input
			_player_intentions();
		}
		
//		vec_scale(aforce,my._FORCE);
		vec_scale(force,my._FORCE);
		
		
	}
	/*
	else
	{ // player controls camera - set actor forces to zero
		vec_set(aforce,nullvector);
		vec_set(force,nullvector);
	}
	*/
}

var move_speed;

function move_player_car_mod()
{

    car_force();
    move_speed = 0;
  
    if (my.skin == 1)
    {
        move_multi_car_1();
//		  car_speed = /*3 * */ my._FORCE_X * time + max( 1 - time * 0.1,0) * car_speed;
  		  move_speed = player1.car_speed;
  		  //my.pan = player1.pan;
  		  if (OK_TO_RACE)
    		{
      	  move_mode = ignore_sprites + activate_trigger + use_box + ignore_passable + glide;
      		ent_move(move_speed,nullvector);
    		}
		}
		if (my.skin == 2)
		{
  		  move_multi_car_2();
  //  		  client_1_car_speed =  my._FORCE_X * time + max( 1 - time * 0.1,0) * client_1_car_speed;
   		  move_speed = player2.car_speed;
   		  //my.pan = player2.pan;

   		  if (OK_TO_RACE)
    		{
      	  move_mode = ignore_sprites + activate_trigger + use_box + ignore_passable + glide;
      		ent_move(move_speed,nullvector);
    		}
		} 
		if (my.skin == 3)
		{
		  client_2_car_speed =  my._FORCE_X * time + max( 1 - time * 0.1,0) * client_2_car_speed;
		  move_speed = client_2_car_speed;
		} 
		if (my.skin == 4)
		{
		  client_3_car_speed =  my._FORCE_X * time + max( 1 - time * 0.1,0) * client_3_car_speed;
		  move_speed = client_3_car_speed;
		} 
		
		/*
		if (move_speed > 1)
		{
		  my.pan += 2 * my._AFORCE_PAN *  time;
		}
		*/
		
		/*
		if (OK_TO_RACE)
		{
  	  move_mode = ignore_sprites + activate_trigger + use_box + ignore_passable + glide;
  		ent_move(move_speed,nullvector);
		}
		*/		
//		move_carview();
}

var force_x;
var force_y;

function move_multi_car_1()
{

//    my = Player1;
    
    car_force();
    
    
    force_y = player1._FORCE_X;
    force_x = player1._FORCE_Y;
    
    
		if (player1.car_speed != 0)
		{
		  if (force_x != 0)
		  {
			  turn_ratio = player_speed_max / player1.car_speed;
			  if (turn_ratio > 4)
			  {
			    turn_ratio = 4;
			  } 
			  player1.pan -= (0.88 * turn_ratio) * force_x *  time;
			  if (player1.car_speed > (player_speed_max * .85))
			  {
			    player1.accelerator = player1.accelerator * .9985;
			    player1.car_speed = player1.car_speed * .9985;
			  }
		  }
		  if (force_x < 0)
		  {			  
		    if (player1.frame < 17)
		    {
		      player1.frame = 19;
		    }
		    
        player1.frame += 1;
        if (player1.frame > 26)
        {
          player1.frame = 26;
        }        	       
		  }

		  if (force_x > 0)
		  {			 		 			     
		    if (player1.frame < 27)
		    {
		      player1.frame = 27;
		    }
		    player1.frame += 1;

			  if (player1.frame > 35)
			  {
			    player1.frame = 35;
			  } 
			}
			  
		  if (force_x == 0)
		  {
		    if (player1.frame > 1) 
		    {
		      player1.frame -= 1;
		      if (player1.frame == 27)
		      {
		        player1.frame = 1;
		      }
		    }
		  }	
	  }
	  
		if (force_y > .5)
		{
		  if (player1.car_speed < player_speed_max)
		  {
		      player1.accelerator += (force_y * .15);
		  }
		  if (player1.accelerator > player_speed_max)
		  {
		    player1.accelerator = player_speed_max;
		  } 
		}
		else
		{
		  player1.accelerator = player1.accelerator * .99;
		  if (player1.accelerator < 0)
		  {
		    player1.accelerator = 0;
		  }
		}
    
    /*
    if ((player_car_done == 1) && (my.x < -19000))
    {
      accelerator -= 2;
      if (accelerator < 0)
      {
        accelerator = 0;
      }
    }
    */
    
    
		player1.car_speed = (2.5 * player1.accelerator * time) + max( 1 - time * 0.1,0) * (player1.car_speed / 2);
    
    if (!OK_TO_RACE)
    {
      player1.car_speed = 0;
      player1.accelerator = 0;
    }
      
		
		if (player1.car_speed > player_speed_max)
	  {
	    player1.car_speed = player_speed_max;
	  }
	
    if (OK_TO_RACE > 0)
    {

      trace_mode = ignore_sprites + ignore_me + ignore_passable + ignore_models + use_box;
      vec_set(temp,player1.x);
      temp.x = temp.x + cos(my.pan) * 200;
      temp.y = temp.y + sin(my.pan) * 200;

      dist = trace (player1.x,temp);
      
      if ((dist < player1.car_speed) && (dist != 0))
      {
      	vec_for_vertex(hit_vec,player1,487);
	
    		x_diff = player1.x - hit_vec.x;
    		y_diff = player1.y - hit_vec.y;
    		z_diff = player1.z - hit_vec.z;
		
        if (abs(x_diff) > abs(y_diff))
        {
      		if (x_diff < 0)
      		{
      		   player1.pan += normal.y;
      		}
      		else
      		{
      		  player1.pan -= normal.y;
      		}
    		}
    		else
    		{
    		  if (y_diff > 0)
      		{
      		   player1.pan += normal.x;
      		}
      		else
      		{
      		  player1.pan -= normal.x;
      		}
      	}
      	
      	if ((snd_playing(wham_hand) == 0) && (setting_audio))
        {
          wham_hand = ent_playsound(player1,wham_snd,1000);
        }
      	
      	player1.car_speed = player1.car_speed * .97;
      	player1.accelerator = player1.accelerator * .97;
      }

      //move_mode = ignore_passable + ignore_sprites + use_box + glide;
			//ent_move(car_speed,nullvector);

		}

				
		move_carview();
		
		if (player1.path_count < 10)
	  {
	    str_cpy(paths,"Path_00");
	  }
	  else
	  {
	    str_cpy(paths,"Path_0"); 
	  }
	  str_for_num(temp_string,player.path_count);
	  str_cat(paths,temp_string);
	  
	  ent_path (paths);
	  
  	if (result > 0)
  	{
        ent_waypoint(my._TARGET_X,2);
        temp.x = my._TARGET_X - my.x;
	      temp.y = my._TARGET_Y - my.y;
	      temp.z = 0;
	      result = vec_to_angle(my_angle,temp);
	      if (result < 1500)
	      {
	        player1.path_time = GetAccurateTime() - start_time;
	        player1.path_count += 1;
          if (player1.path_count > path_max)
          {
		        start_lap_time = GetAccurateTime();  
            player1.path_count = 1;
            my.lap += 1;
            player1.path_time = GetAccurateTime() - start_time;
            if (my.lap > single_lap_max)
            {
              my.car_done = 1;
            }
            else
            {
              show_lap_count();
              str_cpy (line_4_str,"Lap ");
              str_for_num(temp_string,my.lap);
              str_cat(line_4_str,temp_string);
              str_for_num(temp_string,(single_lap_max));
              str_cat(line_4_str," OF ");
              str_cat(line_4_str,temp_string);  
            }
          }
        }          
        set_places();   
  	}

}


function move_multi_car_2()
{

    car_force();
    
    force_y = player2._FORCE_X;
    force_x = player2._FORCE_Y;
    
    if (force_x < -1)
    {
      force_x = -1;
    }
    if (force_x > 1)
    {
      force_x = 1;
    }
    
    if (force_y < -1)
    {
      force_y = -1;
    }
    if (force_y > 1)
    {
      force_y = 1;
    }
    
		if (player2.car_speed != 0)
		{
		  if (force_x != 0)
		  {
			  turn_ratio = player_speed_max / player2.car_speed;
			  if (turn_ratio > 4)
			  {
			    turn_ratio = 4;
			  } 
			  player2.pan -= (0.88 * turn_ratio) * force_x *  time;
			  if (player2.car_speed > (player_speed_max * .85))
			  {
			    player2.accelerator = player2.accelerator * .9985;
			    player2.car_speed = player2.car_speed * .9985;
			  }
		  }
		  if (force_x < 0)
		  {			  
		    if (player2.frame < 17)
		    {
		      player2.frame = 19;
		    }
		    
        player2.frame += 1;
        if (player2.frame > 26)
        {
          player2.frame = 26;
        }        	       
		  }

		  if (force_x > 0)
		  {			 		 			     
		    if (player2.frame < 27)
		    {
		      player2.frame = 27;
		    }
		    player2.frame += 1;

			  if (player2.frame > 35)
			  {
			    player2.frame = 35;
			  } 
			}
			  
		  if (force_x == 0)
		  {
		    if (player2.frame > 1) 
		    {
		      player2.frame -= 1;
		      if (player2.frame == 27)
		      {
		        player2.frame = 1;
		      }
		    }
		  }	
	  }
	  
		if (force_y > .5)
		{
		  if (player2.car_speed < player_speed_max)
		  {
		      player2.accelerator += (force_y * .15);
		  }
		  if (player2.accelerator > player_speed_max)
		  {
		    player2.accelerator = player_speed_max;
		  } 
		}
		else
		{
		  player2.accelerator = player2.accelerator * .99;
		  if (player2.accelerator < 0)
		  {
		    player2.accelerator = 0;
		  }
		}
    
    /*
    if ((player_car_done == 1) && (my.x < -19000))
    {
      accelerator -= 2;
      if (accelerator < 0)
      {
        accelerator = 0;
      }
    }
    */
    
    
		player2.car_speed = (2.5 * player2.accelerator * time) + max( 1 - time * 0.1,0) * (player2.car_speed / 2);

    if (!OK_TO_RACE)
    {
      player2.car_speed = 0;
      player2.accelerator = 0;
    }
		
		if (player2.car_speed > player_speed_max)
	  {
	    player2.car_speed = player_speed_max;
	  }
	
    if (OK_TO_RACE > 0)
    {

      trace_mode = ignore_sprites + ignore_me + ignore_passable + ignore_models + use_box;
      vec_set(temp,player2.x);
      temp.x = temp.x + cos(player2.pan) * 200;
      temp.y = temp.y + sin(player2.pan) * 200;

      dist = trace (player2.x,temp);
      
      if ((dist < player2.car_speed) && (dist != 0))
      {
      	vec_for_vertex(hit_vec,player2,487);
	
    		x_diff = player2.x - hit_vec.x;
    		y_diff = player2.y - hit_vec.y;
    		z_diff = player2.z - hit_vec.z;
		
        if (abs(x_diff) > abs(y_diff))
        {
      		if (x_diff < 0)
      		{
      		   player2.pan += normal.y;
      		}
      		else
      		{
      		  player2.pan -= normal.y;
      		}
    		}
    		else
    		{
    		  if (y_diff > 0)
      		{
      		   player2.pan += normal.x;
      		}
      		else
      		{
      		  player2.pan -= normal.x;
      		}
      	}
      	
      	if (snd_playing(wham_hand) == 0)
        {
          wham_hand = ent_playsound(player2,wham_snd,1000);
        }
      	
      	player2.car_speed = player2.car_speed * .97;
      	player2.accelerator = player2.accelerator * .97;
      }
  
		}

				
		move_carview();
		
		if (player2.path_count < 10)
	  {
	    str_cpy(paths,"Path_00");
	  }
	  else
	  {
	    str_cpy(paths,"Path_0"); 
	  }
	  str_for_num(temp_string,player2.path_count);
	  str_cat(paths,temp_string);
	  
	  ent_path (paths);
	  
  	if (result > 0)
  	{
        ent_waypoint(my._TARGET_X,2);
        temp.x = my._TARGET_X - my.x;
	      temp.y = my._TARGET_Y - my.y;
	      temp.z = 0;
	      result = vec_to_angle(my_angle,temp);
	      if (result < 1500)
	      {
	        player2.path_time = GetAccurateTime() - start_time;
	        player2.path_count += 1;
          if (player2.path_count > path_max)
          {
		        start_lap_time = GetAccurateTime();  
            player2.path_count = 1;
            player2.lap += 1;
            player2.path_time = GetAccurateTime() - start_time;
            if (player2.lap > single_lap_max)
            {
              my.car_done = 1;
            }
            else
            {
              show_lap_count();
              str_cpy (line_4_str,"Lap ");
              str_for_num(temp_string,player2.lap);
              str_cat(line_4_str,temp_string);
              str_for_num(temp_string,(single_lap_max));
              str_cat(line_4_str," OF ");
              str_cat(line_4_str,temp_string);  
            }
          }
        }          
        set_places();   
  	}

}


/*
sky mountain {
// A backdrop texture's horizontal size must be a power of 2;
// the vertical size does not matter
	type = <zionlow.pcx>;
	scale_x = .15;	// gives a field of 90 degrees per texture
	tilt = -10;
	flags = scene,overlay,visible;
	layer = 4;
}
*/

sky cloud {
	type = <sky16.bmp>;
	scale_x = .25;	// gives a field of 90 degrees per texture
	tilt = -10;
	flags = scene,overlay,visible,;
	layer = 3;
}

var cam_dist[3];
var cam_ang[3];

function move_carview()
{

	if(player == null) { player = me; }	// this action needs the player pointer
	if(player == null) { return; }			// still no player -> can't work


  if (my.car_done == 0)
  {
    if (my.spin_out > 0) 
    {
        if (dash_view == 1)
        {
        	camera.x = player.x - cos(player.pan) * 10;
        	camera.y = player.y - sin(player.pan) * 10;
        	camera.z = player.z + 18;
        	camera.pan = player.pan;
        	camera.roll = 0;
        	camera.tilt = player.tilt;
        }
    }
    else
    {
      if (!fix_pan)
      {
        if (dash_view == 1)
        {
        	camera.x = player.x - cos(player.pan) * 10;
        	camera.y = player.y - sin(player.pan) * 10;
        	camera.z = player.z + 18;
        	camera.pan = player.pan;
        	camera.roll = 0;
        	camera.tilt = player.tilt;
        }
        else
        {
          camera.x = player.x - cos(player.pan) * 260;
          camera.y = player.y - sin(player.pan) * 260;
          camera.z = player.z + 64;
  	      camera.roll = 0;
  	      camera.tilt = -11;
          camera.pan = player.pan;  
        }
      }    
    }
    
    if (fix_pan)
    {
        vec_diff(cam_dist,player.x,camera.x);
        vec_to_angle(cam_ang,cam_dist);
        if (vec_length(cam_dist) < 360)
        {
            fix_pan = 0;
        }
        
        vec_normalize(cam_dist,(25 + my.car_speed));
        vec_add(camera.x,cam_dist);
        
    }
  	
	}
	
}




function move_client_carview()
{
  
//	camera.x = player.x - cos(player.pan) * 200;
//	camera.y = player.y - sin(player.pan) * 200;
  camera.x = player2.x - cos(player2.pan) * 100;
  camera.y = player2.y - sin(player2.pan) * 100;
	camera.z = player2.z + 10;
	camera.pan = player2.pan;
	camera.roll = 0;
	camera.tilt = 0;
	
}


window WINSTART
{
	title			"Great Clips 500";
	size			480,320;
	mode			IMAGE;	//STANDARD;
	bg_color		RGB(240,240,240);
	frame			FTYP4,0,0,480,320;
	BG_PATTERN <LOADER.BMP>,OPAQUE;
	PROGRESS RGB(248,248,8),83,29,196,225,28;
	
//	BUTTON		BUTTON_START,SYS_DEFAULT,"Start",400,288,72,24;
	button		BUTTON_QUIT,SYS_DEFAULT,"Abort",400,288,72,24;
	TEXT_STDOUT	"Arial",RGB(0,0,0),10,10,460,280;
}


function esc_game_over()
{
  esc_hit += 1;
  if (esc_hit > 1)
  {
    game_over_pan.visible = OFF;
    esc_hit = 0;
  }
  
  if (esc_hit == 1)
  {
    game_over_pan.visible = ON;
  }  
}

function game_help()
{
  help_hit += 1;
  if (help_hit > 1)
  {
    help_pan.visible = OFF;
    help_hit = 0;
  }
  
  if (help_hit == 1)
  {
    help_pan.visible = ON;
  }
} 


function dash_cam() //Target camera. Attributes
{

  if (dash_view == 1) { dash_view = 0;} else { dash_view = 1;}   
  
  if (dash_view)
  {
    Dash.visible = ON;
    player.invisible = ON;
  }
  else
  {
    Dash.visible = OFF;
    player.invisible = OFF;
  }   

}



on_r blimp_cam();
on_space start_multi_race();
//on_s drone_spin_out();
on_esc esc_game_over();
on_c dash_cam();
on_f1 game_help();
	
	

	


